$(() => {
const deployment = 'gpt-4o-mini';
const apiVersion = '2024-02-01';
const endpoint = 'https://public-api.devexpress.com/demo-openai';
const apiKey = 'DEMO';
const aiService = new AzureOpenAI({
dangerouslyAllowBrowser: true,
deployment,
endpoint,
apiVersion,
apiKey,
});
async function getAIResponse(messages, signal) {
const params = {
messages,
model: deployment,
max_tokens: 1000,
temperature: 0.7,
};
const response = await aiService.chat.completions
.create(params, { signal });
const result = response.choices[0].message?.content;
return result;
}
async function getAIResponseRecursive(messages, signal) {
return getAIResponse(messages, signal)
.catch(async (error) => {
if (!error.message.includes('Connection error')) {
return Promise.reject(error);
}
DevExpress.ui.notify({
message: 'Our demo AI service reached a temporary request limit. Retrying in 30 seconds.',
width: 'auto',
type: 'error',
displayTime: 5000,
});
await new Promise((resolve) => setTimeout(resolve, 30000));
return getAIResponseRecursive(messages, signal);
});
}
const aiIntegration = new DevExpress.aiIntegration({
sendRequest({ prompt }) {
const isValidRequest = JSON.stringify(prompt.user).length < 5000;
if (!isValidRequest) {
return {
promise: Promise.reject(new Error('Request is too long. Specify a shorter prompt.')),
abort: () => {},
};
}
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt = [
{ role: 'system', content: prompt.system },
{ role: 'user', content: prompt.user },
];
const promise = getAIResponseRecursive(aiPrompt, signal);
const result = {
promise,
abort: () => {
controller.abort();
},
};
return result;
},
});
const createNameTemplate = (employee) => {
const {
ID,
First_Name,
Last_Name,
} = employee;
if (!ID || !First_Name || !Last_Name) {
return $('<div>').text('');
}
const nameWrapper = $('<div>').addClass('name__wrapper');
const imgWrapper = $('<div>').addClass('name__img-wrapper');
const img = $('<img>').addClass('name__img');
img.attr({
src: `../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`,
alt: `${First_Name} ${Last_Name}`,
});
imgWrapper.append(img);
nameWrapper.append(imgWrapper);
const textWrapper = $('<div>').addClass('name__text-wrapper');
const firstNameText = $('<div>').addClass('name__text').text(First_Name);
const lastNameText = $('<div>').addClass('name__text').text(Last_Name);
textWrapper.append(firstNameText, lastNameText);
nameWrapper.append(textWrapper);
return nameWrapper;
};
const createStatusTemplate = (status) => $('<div>')
.append(
$('<div>').addClass('indicator'),
)
.append(
$('<div>').text(status),
)
.addClass('status')
.toggleClass('status--salaried', status === 'Salaried')
.toggleClass('status--commission', status === 'Commission')
.toggleClass('status--terminated', status === 'Terminated');
$('#treeList').dxTreeList({
dataSource: employees,
showBorders: true,
keyExpr: 'ID',
parentIdExpr: 'Head_ID',
autoExpandAll: true,
aiIntegration,
scrolling: {
mode: 'standard',
},
paging: {
enabled: true,
pageSize: 10,
},
columns: [
{
caption: 'Employee',
width: 260,
cellTemplate: (container, options) => {
const employee = options.data;
const imageWrapper = createNameTemplate(employee);
container.append(imageWrapper);
},
cssClass: 'name_cell',
},
{
dataField: 'Title',
caption: 'Position',
width: 140,
},
{
dataField: 'Status',
cellTemplate: (container, options) => {
const status = options.data.Status;
const statusWrapper = createStatusTemplate(status);
container.append(statusWrapper);
},
minWidth: 180,
},
{
dataField: 'City',
width: 180,
},
{
dataField: 'State',
width: 140,
},
{
dataField: 'Email',
minWidth: 200,
},
{
name: 'AI Column',
caption: 'AI Column',
type: 'ai',
ai: {
prompt: 'Identify the department where the employee works. Select from the following department list: "Management", "Human Resources", "IT", "Shipping", "Support", "Sales", "Engineering". Use "Engineering" if you cannot find a better match.',
mode: 'auto',
noDataText: 'No data',
},
width: 180,
fixed: true,
fixedPosition: 'right',
cssClass: 'ai__cell',
},
],
onAIColumnRequestCreating(e) {
e.data = e.data.map((item) => ({
ID: item.ID,
First_Name: item.First_Name,
Last_Name: item.Last_Name,
Title: item.Title,
}));
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.3/css/dx.light.css" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="js/dx.all.js?v=25.2.3"></script>
<script src="js/dx.ai-integration.js"></script>
<script type="module">
import { AzureOpenAI } from "https://esm.sh/openai@4.73.1";
window.AzureOpenAI = AzureOpenAI;
</script>
<script src="data.js"></script>
<script src="index.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="tree-list-demo">
<div id="treeList"></div>
</div>
</div>
</body>
</html>
#treeList {
min-height: 560px;
}
#treeList .ai__cell {
background-color: var(--dx-datagrid-row-alternation-bg);
}
#treeList .name_cell > div {
align-items: flex-end;
}
.name__wrapper {
display: flex;
align-items: center;
gap: 8px;
}
.name__img-wrapper {
width: 40px;
height: 40px;
border: var(--dx-border-width) solid var(--dx-color-border);
border-radius: 50%;
cursor: pointer;
}
.name__img-wrapper img {
width: 100%;
height: 100%;
object-fit: cover;
object-position: center;
border-radius: 50%;
}
.name__text-wrapper {
width: calc(100% - 48px);
}
.name__text {
margin: 0;
padding: 0;
white-space: nowrap;
overflow: hidden;
text-overflow: ellipsis;
}
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: #f7630c;
}
.status--terminated {
color: var(--dx-color-danger);
}
.indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}
const employees = [{
ID: 1,
Head_ID: 0,
First_Name: 'John',
Last_Name: 'Heart',
Prefix: 'Mr.',
Title: 'CEO',
City: 'Los Angeles',
State: 'California',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
Mobile_Phone: '(213) 555-9392',
Birth_Date: '1964-03-16',
Hire_Date: '1995-01-15',
Status: 'Salaried',
}, {
ID: 3,
Head_ID: 1,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
}, {
ID: 4,
Head_ID: 1,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
}, {
ID: 5,
Head_ID: 1,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
}, {
ID: 6,
Head_ID: 3,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
}, {
ID: 7,
Head_ID: 5,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
}, {
ID: 21,
Head_ID: 6,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
}, {
ID: 22,
Head_ID: 6,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
}, {
ID: 25,
Head_ID: 6,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
}, {
ID: 28,
Head_ID: 6,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
}, {
ID: 29,
Head_ID: 28,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
}, {
ID: 32,
Head_ID: 3,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
}, {
ID: 36,
Head_ID: 32,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
}, {
ID: 38,
Head_ID: 32,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
}, {
ID: 44,
Head_ID: 4,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
}, {
ID: 45,
Head_ID: 4,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
}, {
ID: 48,
Head_ID: 32,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
}, {
ID: 51,
Head_ID: 32,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
}];

import React from 'react';
import TreeList, {
Column,
Scrolling,
Paging,
AI,
} from 'devextreme-react/tree-list';
import type { TreeListTypes } from 'devextreme-react/tree-list';
import { employees } from './data.ts';
import { aiIntegration } from './service.ts';
import type { Employee as EmployeeType } from './types.ts';
import Employee from './Employee.tsx';
import Status from './Status.tsx';
const onAIColumnRequestCreating = (
e: TreeListTypes.AIColumnRequestCreatingEvent<EmployeeType>
) => {
e.data = e.data.map((item: EmployeeType) => ({
ID: item.ID,
First_Name: item.First_Name,
Last_Name: item.Last_Name,
Title: item.Title,
}));
};
export default function App() {
return (
<TreeList
id="employees"
showBorders={true}
dataSource={employees}
keyExpr="ID"
parentIdExpr="Head_ID"
autoExpandAll={true}
aiIntegration={aiIntegration}
onAIColumnRequestCreating={onAIColumnRequestCreating}
className="ai__grid"
>
<Paging enabled={true} pageSize={10} />
<Scrolling mode="standard" />
<Column
caption="Employee"
width={260}
cellRender={Employee}
cssClass="name_cell"
/>
<Column
dataField="Title"
caption="Position"
width={140}
/>
<Column
dataField="Status"
minWidth={180}
cellRender={Status}
/>
<Column
dataField="City"
width={180}
/>
<Column
dataField="State"
width={140}
/>
<Column
dataField="Email"
minWidth={200}
/>
<Column
name="AI Column"
caption="AI Column"
type="ai"
width={180}
fixed={true}
fixedPosition="right"
cssClass="ai__cell"
>
<AI
mode="auto"
noDataText="No data"
prompt="Identify the department where the employee works. Select from the following department list: 'Management', 'Human Resources', 'IT', 'Shipping', 'Support', 'Sales', 'Engineering'. Use 'Engineering' if you cannot find a better match."
/>
</Column>
</TreeList>
);
}
import React from 'react';
import TreeList, {
Column, Scrolling, Paging, AI,
} from 'devextreme-react/tree-list';
import { employees } from './data.js';
import { aiIntegration } from './service.js';
import Employee from './Employee.js';
import Status from './Status.js';
const onAIColumnRequestCreating = (e) => {
e.data = e.data.map((item) => ({
ID: item.ID,
First_Name: item.First_Name,
Last_Name: item.Last_Name,
Title: item.Title,
}));
};
export default function App() {
return (
<TreeList
id="employees"
showBorders={true}
dataSource={employees}
keyExpr="ID"
parentIdExpr="Head_ID"
autoExpandAll={true}
aiIntegration={aiIntegration}
onAIColumnRequestCreating={onAIColumnRequestCreating}
className="ai__grid"
>
<Paging
enabled={true}
pageSize={10}
/>
<Scrolling mode="standard" />
<Column
caption="Employee"
width={260}
cellRender={Employee}
cssClass="name_cell"
/>
<Column
dataField="Title"
caption="Position"
width={140}
/>
<Column
dataField="Status"
minWidth={180}
cellRender={Status}
/>
<Column
dataField="City"
width={180}
/>
<Column
dataField="State"
width={140}
/>
<Column
dataField="Email"
minWidth={200}
/>
<Column
name="AI Column"
caption="AI Column"
type="ai"
width={180}
fixed={true}
fixedPosition="right"
cssClass="ai__cell"
>
<AI
mode="auto"
noDataText="No data"
prompt="Identify the department where the employee works. Select from the following department list: 'Management', 'Human Resources', 'IT', 'Shipping', 'Support', 'Sales', 'Engineering'. Use 'Engineering' if you cannot find a better match."
/>
</Column>
</TreeList>
);
}
import React from 'react';
import { type TreeListTypes } from 'devextreme-react/tree-list';
import { type Employee } from './types';
export default function Employee(props: TreeListTypes.ColumnCellTemplateData<Employee>) {
const { First_Name, Last_Name } = props.data;
return (
<div className="name__wrapper">
<div className="name__img-wrapper">
<img
src={`../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`}
alt={`${First_Name} ${Last_Name}`}
/>
</div>
<div className="name__text-wrapper">
<div className="name__text">{First_Name}</div>
<div className="name__text">{Last_Name}</div>
</div>
</div>
);
}
import React from 'react';
import { type TreeListTypes } from 'devextreme-react/tree-list';
import { type Employee } from './types';
export default function Status(props: TreeListTypes.ColumnCellTemplateData<Employee>) {
const { Status } = props.data;
const statusClass = Status ? `status status--${Status.toLowerCase()}` : '';
return (
<div className={statusClass}>
<div className="indicator" />
<div>{Status}</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import { type Employee } from "./types";
export const employees: Employee[] = [{
ID: 1,
Head_ID: 0,
First_Name: 'John',
Last_Name: 'Heart',
Prefix: 'Mr.',
Title: 'CEO',
City: 'Los Angeles',
State: 'California',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
Mobile_Phone: '(213) 555-9392',
Birth_Date: '1964-03-16',
Hire_Date: '1995-01-15',
Status: 'Salaried',
}, {
ID: 3,
Head_ID: 1,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
}, {
ID: 4,
Head_ID: 1,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
}, {
ID: 5,
Head_ID: 1,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
}, {
ID: 6,
Head_ID: 3,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
}, {
ID: 7,
Head_ID: 5,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
}, {
ID: 21,
Head_ID: 6,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
}, {
ID: 22,
Head_ID: 6,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
}, {
ID: 25,
Head_ID: 6,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
}, {
ID: 28,
Head_ID: 6,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
}, {
ID: 29,
Head_ID: 28,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
}, {
ID: 32,
Head_ID: 3,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
}, {
ID: 36,
Head_ID: 32,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
}, {
ID: 38,
Head_ID: 32,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
}, {
ID: 44,
Head_ID: 4,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
}, {
ID: 45,
Head_ID: 4,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
}, {
ID: 48,
Head_ID: 32,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
}, {
ID: 51,
Head_ID: 32,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
}];
import { AzureOpenAI } from 'openai';
import { AIIntegration } from 'devextreme-react/common/ai-integration';
import type {
RequestParams,
Response,
} from 'devextreme-react/common/ai-integration';
import notify from 'devextreme/ui/notify';
import type { AIMessage } from './types.ts';
const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'gpt-4o-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
const aiService = new AzureOpenAI(AzureOpenAIConfig);
async function getAIResponse(messages: AIMessage[], signal: AbortSignal): Promise<string> {
const params = {
messages,
model: AzureOpenAIConfig.deployment,
max_tokens: 1000,
temperature: 0.7,
};
const response = await aiService.chat.completions.create(params, { signal });
const result = response.choices[0].message?.content;
return result ?? '';
}
async function getAIResponseRecursive(messages: AIMessage[], signal: AbortSignal): Promise<string> {
return getAIResponse(messages, signal)
.catch(async (error) => {
if (!error.message.includes('Connection error')) {
return Promise.reject(error);
}
notify({
message: 'Our demo AI service reached a temporary request limit. Retrying in 30 seconds.',
width: 'auto',
type: 'error',
displayTime: 5000,
});
await new Promise((resolve) => setTimeout(resolve, 30000));
return getAIResponseRecursive(messages, signal);
});
}
export const aiIntegration = new AIIntegration({
sendRequest({ prompt }: RequestParams): Response {
const isValidRequest = JSON.stringify(prompt.user).length < 5000;
if (!isValidRequest) {
return {
promise: Promise.reject(new Error('Request is too long. Specify a shorter prompt.')),
abort: () => {},
};
}
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt: AIMessage[] = [
{ role: 'system', content: prompt.system ?? '' },
{ role: 'user', content: prompt.user ?? '' },
];
const promise = getAIResponseRecursive(aiPrompt, signal);
const result: Response = {
promise,
abort: () => {
controller.abort();
},
};
return result;
},
});
import { OpenAI } from 'openai';
export type AIMessage = (OpenAI.ChatCompletionUserMessageParam | OpenAI.ChatCompletionSystemMessageParam) & {
content: string;
};
export type Employee = {
ID: number;
Head_ID?: number;
First_Name: string;
Last_Name: string;
Prefix?: string;
Title: string;
City?: string;
State?: string;
Email?: string;
Skype?: string;
Mobile_Phone?: string;
Birth_Date?: string;
Hire_Date?: string;
Status?: string;
};
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'openai': 'externals:openai.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"openai": {
"version": "4.73.1"
}
};
import React from 'react';
export default function Employee(props) {
const { First_Name, Last_Name } = props.data;
return (
<div className="name__wrapper">
<div className="name__img-wrapper">
<img
src={`../../../../images/employees/new/${First_Name} ${Last_Name}.jpg`}
alt={`${First_Name} ${Last_Name}`}
/>
</div>
<div className="name__text-wrapper">
<div className="name__text">{First_Name}</div>
<div className="name__text">{Last_Name}</div>
</div>
</div>
);
}
import { AzureOpenAI } from 'openai';
import { AIIntegration } from 'devextreme-react/common/ai-integration';
import notify from 'devextreme/ui/notify';
const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'gpt-4o-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
const aiService = new AzureOpenAI(AzureOpenAIConfig);
async function getAIResponse(messages, signal) {
const params = {
messages,
model: AzureOpenAIConfig.deployment,
max_tokens: 1000,
temperature: 0.7,
};
const response = await aiService.chat.completions.create(params, { signal });
const result = response.choices[0].message?.content;
return result ?? '';
}
async function getAIResponseRecursive(messages, signal) {
return getAIResponse(messages, signal).catch(async (error) => {
if (!error.message.includes('Connection error')) {
return Promise.reject(error);
}
notify({
message: 'Our demo AI service reached a temporary request limit. Retrying in 30 seconds.',
width: 'auto',
type: 'error',
displayTime: 5000,
});
await new Promise((resolve) => setTimeout(resolve, 30000));
return getAIResponseRecursive(messages, signal);
});
}
export const aiIntegration = new AIIntegration({
sendRequest({ prompt }) {
const isValidRequest = JSON.stringify(prompt.user).length < 5000;
if (!isValidRequest) {
return {
promise: Promise.reject(new Error('Request is too long. Specify a shorter prompt.')),
abort: () => {},
};
}
const controller = new AbortController();
const signal = controller.signal;
const aiPrompt = [
{ role: 'system', content: prompt.system ?? '' },
{ role: 'user', content: prompt.user ?? '' },
];
const promise = getAIResponseRecursive(aiPrompt, signal);
const result = {
promise,
abort: () => {
controller.abort();
},
};
return result;
},
});
import React from 'react';
export default function Status(props) {
const { Status } = props.data;
const statusClass = Status ? `status status--${Status.toLowerCase()}` : '';
return (
<div className={statusClass}>
<div className="indicator" />
<div>{Status}</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const employees = [
{
ID: 1,
Head_ID: 0,
First_Name: 'John',
Last_Name: 'Heart',
Prefix: 'Mr.',
Title: 'CEO',
City: 'Los Angeles',
State: 'California',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
Mobile_Phone: '(213) 555-9392',
Birth_Date: '1964-03-16',
Hire_Date: '1995-01-15',
Status: 'Salaried',
},
{
ID: 3,
Head_ID: 1,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
},
{
ID: 4,
Head_ID: 1,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
},
{
ID: 5,
Head_ID: 1,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
},
{
ID: 6,
Head_ID: 3,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
},
{
ID: 7,
Head_ID: 5,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
},
{
ID: 21,
Head_ID: 6,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
},
{
ID: 22,
Head_ID: 6,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
},
{
ID: 25,
Head_ID: 6,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
},
{
ID: 28,
Head_ID: 6,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
},
{
ID: 29,
Head_ID: 28,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
},
{
ID: 32,
Head_ID: 3,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
},
{
ID: 36,
Head_ID: 32,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
},
{
ID: 38,
Head_ID: 32,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
},
{
ID: 44,
Head_ID: 4,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
},
{
ID: 45,
Head_ID: 4,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
},
{
ID: 48,
Head_ID: 32,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
},
{
ID: 51,
Head_ID: 32,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="tree-list-demo">
<div id="app"></div>
</div>
</div>
</body>
</html>
#app .ai__cell {
background-color: var(--dx-datagrid-row-alternation-bg);
}
.ai__grid {
min-height: 560px;
}
#app .name_cell > div {
align-items: flex-end;
}
.name__wrapper {
display: flex;
align-items: center;
gap: 8px;
}
.name__img-wrapper {
width: 40px;
height: 40px;
border: var(--dx-border-width) solid var(--dx-color-border);
border-radius: 50%;
cursor: pointer;
}
.name__img-wrapper img {
width: 100%;
height: 100%;
object-fit: cover;
object-position: center;
border-radius: 50%;
}
.name__text-wrapper {
width: calc(100% - 48px);
}
.name__text {
margin: 0;
padding: 0;
white-space: nowrap;
overflow: hidden;
text-overflow: ellipsis;
}
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: #f7630c;
}
.status--terminated {
color: var(--dx-color-danger);
}
.indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}

<dx-tree-list
id="employees"
keyExpr="ID"
parentIdExpr="Head_ID"
[dataSource]="employees"
[autoExpandAll]="true"
[showBorders]="true"
[aiIntegration]="aiIntegration"
(onAIColumnRequestCreating)="onAIColumnRequestCreating($event)"
>
<dxo-tree-list-scrolling mode="standard" />
<dxo-tree-list-paging [enabled]="true" [pageSize]="10" />
<dxi-tree-list-column
caption="Employee"
cssClass="employee__cell"
[width]="260"
cellTemplate="employeeTemplate"
/>
<div *dxTemplate="let model of 'employeeTemplate'">
<employee
[firstName]="model.data.First_Name"
[lastName]="model.data.Last_Name"
/>
</div>
<dxi-tree-list-column dataField="Title" caption="Position" [width]="140" />
<dxi-tree-list-column
dataField="Status"
[minWidth]="180"
cellTemplate="statusTemplate"
/>
<div *dxTemplate="let model of 'statusTemplate'">
<status [status]="model.data.Status" />
</div>
<dxi-tree-list-column dataField="City" [width]="180" />
<dxi-tree-list-column dataField="State" [width]="140" />
<dxi-tree-list-column dataField="Email" [minWidth]="200" />
<dxi-tree-list-column
name="AI Column"
caption="AI Column"
type="ai"
cssClass="ai__cell"
[fixed]="true"
fixedPosition="right"
[width]="180"
>
<dxo-tree-list-ai
prompt='Identify the department where the employee works. Select from the following department list: "Management", "Human Resources", "IT", "Shipping", "Support", "Sales", "Engineering". Use "Engineering" if you cannot find a better match.'
mode="auto"
noDataText="No data"
/>
</dxi-tree-list-column>
</dx-tree-list>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxTreeListModule } from 'devextreme-angular';
import type { AIIntegration } from 'devextreme-angular/common/ai-integration';
import { Service, type IEmployee } from './app.service';
import { AiService } from './ai/ai.service';
import { Employee } from './employee/employee.component';
import { Status } from './status/status.component';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service, AiService],
imports: [
DxTreeListModule,
Employee,
Status,
],
})
export class AppComponent {
employees: IEmployee[];
aiIntegration: AIIntegration;
constructor(service: Service, aiService: AiService) {
this.employees = service.getEmployees();
this.aiIntegration = aiService.getAiIntegration();
}
onAIColumnRequestCreating(e: { data: Partial<IEmployee>[] }) {
e.data = e.data.map((item) => ({
ID: item.ID,
First_Name: item.First_Name,
Last_Name: item.Last_Name,
Title: item.Title,
}));
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #employees {
min-height: 560px;
}
::ng-deep #employees .ai__cell {
background-color: var(--dx-datagrid-row-alternation-bg);
}
::ng-deep #employees .employee__cell > div {
align-items: flex-end;
}
import { Injectable } from '@angular/core';
export interface IEmployee {
ID: number;
Head_ID: number;
First_Name: string;
Last_Name: string;
Prefix: string;
Title: string;
City: string;
State: string;
Email: string;
Skype?: string;
Mobile_Phone: string;
Birth_Date: string;
Hire_Date: string;
Status: string;
}
export const employees: IEmployee[] = [{
ID: 1,
Head_ID: 0,
First_Name: 'John',
Last_Name: 'Heart',
Prefix: 'Mr.',
Title: 'CEO',
City: 'Los Angeles',
State: 'California',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
Mobile_Phone: '(213) 555-9392',
Birth_Date: '1964-03-16',
Hire_Date: '1995-01-15',
Status: 'Salaried',
}, {
ID: 3,
Head_ID: 1,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
}, {
ID: 4,
Head_ID: 1,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
}, {
ID: 5,
Head_ID: 1,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
}, {
ID: 6,
Head_ID: 3,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
}, {
ID: 7,
Head_ID: 5,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
}, {
ID: 21,
Head_ID: 6,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
}, {
ID: 22,
Head_ID: 6,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
}, {
ID: 25,
Head_ID: 6,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
}, {
ID: 28,
Head_ID: 6,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
}, {
ID: 29,
Head_ID: 28,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
}, {
ID: 32,
Head_ID: 3,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
}, {
ID: 36,
Head_ID: 32,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
}, {
ID: 38,
Head_ID: 32,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
}, {
ID: 44,
Head_ID: 4,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
}, {
ID: 45,
Head_ID: 4,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
}, {
ID: 48,
Head_ID: 32,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
}, {
ID: 51,
Head_ID: 32,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
}];
@Injectable()
export class Service {
getEmployees() {
return employees;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'openai': 'externals:openai.bundle.js',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"openai": {
"version": "4.73.1"
},
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
import { AzureOpenAI, OpenAI } from 'openai';
import { Injectable } from '@angular/core';
import notify from 'devextreme/ui/notify';
import {
AIIntegration,
type RequestParams,
type Response,
} from 'devextreme-angular/common/ai-integration';
type AIMessage = (OpenAI.ChatCompletionUserMessageParam | OpenAI.ChatCompletionSystemMessageParam) & {
content: string;
};
const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'demo-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
const RATE_LIMIT_RETRY_DELAY_MS = 30000;
const MAX_PROMPT_SIZE = 5000;
const service = new AzureOpenAI(AzureOpenAIConfig);
async function getAIResponse(messages: AIMessage[], signal: AbortSignal) {
const params = {
messages,
model: AzureOpenAIConfig.deployment,
max_completion_tokens: 1000,
temperature: 0.7,
};
const response = await service.chat.completions.create(params, { signal });
const result = response.choices[0].message?.content;
if (!result) {
throw new Error('AI response returned empty content');
}
return result;
}
function getAIResponseRecursive(messages: AIMessage[], signal: AbortSignal): Promise<string> {
return getAIResponse(messages, signal)
.catch(async (error) => {
if (!error.message.includes('Connection error')) {
return Promise.reject(error);
}
notify({
message: 'Our demo AI service reached a temporary request limit. Retrying in 30 seconds.',
width: 'auto',
type: 'error',
displayTime: 5000,
});
await new Promise((resolve) => setTimeout(resolve, RATE_LIMIT_RETRY_DELAY_MS));
return getAIResponseRecursive(messages, signal);
});
}
const aiIntegration = new AIIntegration({
sendRequest({ prompt }: RequestParams): Response {
const isValidRequest = JSON.stringify(prompt.user).length < MAX_PROMPT_SIZE;
if (!isValidRequest) {
return {
promise: Promise.reject(new Error('Request is too long. Specify a shorter prompt.')),
abort: () => {},
};
}
const controller = new AbortController();
const signal = controller.signal;
if (!prompt.user || !prompt.system) {
throw new Error('Invalid prompt data');
}
const aiPrompt: AIMessage[] = [
{ role: 'system', content: prompt.system },
{ role: 'user', content: prompt.user },
];
const promise = getAIResponseRecursive(aiPrompt, signal);
const result: Response = {
promise,
abort: () => {
controller.abort();
},
};
return result;
},
});
@Injectable()
export class AiService {
getAiIntegration() {
return aiIntegration;
}
}
.employee__wrapper {
display: flex;
align-items: center;
gap: 8px;
}
.employee__img-wrapper {
width: 40px;
height: 40px;
border: var(--dx-border-width) solid var(--dx-color-border);
border-radius: 50%;
cursor: pointer;
}
.employee__img-wrapper img {
width: 100%;
height: 100%;
object-fit: cover;
object-position: center;
border-radius: 50%;
}
.employee__text-wrapper {
width: calc(100% - 48px);
}
.employee__text {
margin: 0;
padding: 0;
white-space: nowrap;
overflow: hidden;
text-overflow: ellipsis;
}
<div class="employee__wrapper">
<div class="employee__img-wrapper">
<img
src="../../../../images/employees/new/{{ firstName }} {{ lastName }}.jpg"
alt="{{ firstName }} {{ lastName }}"
/>
</div>
<div class="employee__text-wrapper">
<div class="employee__text">{{ firstName }}</div>
<div class="employee__text">{{ lastName }}</div>
</div>
</div>
import { Component, Input } from '@angular/core';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'employee',
templateUrl: `app/employee/employee.component.html`,
styleUrls: [`app/employee/employee.component.css`],
})
export class Employee {
@Input() firstName!: string;
@Input() lastName!: string;
}
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: var(--dx-color-warning);
}
.status--terminated {
color: var(--dx-color-danger);
}
.status__indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}
<div class="status status--{{ status.toLowerCase() }}">
<div class="status__indicator"></div>
<div>{{ status }}</div>
</div>
import { Component, Input } from '@angular/core';
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'status',
templateUrl: `app/status/status.component.html`,
styleUrls: [`app/status/status.component.css`],
})
export class Status {
@Input() status!: string;
}

<template>
<DxTreeList
id="employees"
keyExpr="ID"
parentIdExpr="Head_ID"
:dataSource="employees"
:autoExpandAll="true"
:showBorders="true"
:aiIntegration="aiIntegration"
:onAIColumnRequestCreating="onAIColumnRequestCreating"
class="ai__grid"
>
<DxScrolling :mode="'standard'"/>
<DxPaging
:enabled="true"
:pageSize="10"
/>
<DxColumn
caption="Employee"
cssClass="employee__cell"
:width="260"
cellTemplate="employee-cell"
/>
<template #employee-cell="{ data: { data: employee} }">
<Employee
:firstName="employee.First_Name"
:lastName="employee.Last_Name"
/>
</template>
<DxColumn
dataField="Title"
caption="Position"
:width="140"
/>
<DxColumn
dataField="Status"
:minWidth="180"
cellTemplate="status-cell"
/>
<template #status-cell="{ data: { data: employee} }">
<Status :status="employee.Status"/>
</template>
<DxColumn
dataField="City"
:width="180"
/>
<DxColumn
dataField="State"
:width="140"
/>
<DxColumn
dataField="Email"
:minWidth="200"
/>
<DxColumn
name="AI Column"
caption="AI Column"
type="ai"
cssClass="ai__cell"
:fixed="true"
fixedPosition="right"
:width="180"
>
<DxAI
mode="auto"
noDataText="No data"
prompt="Identify the department where the employee works.
Select from the following department list: 'Management', 'Human Resources', 'IT', 'Shipping',
'Support', 'Sales', 'Engineering'. Use 'Engineering' if you cannot find a better match."
/>
</DxColumn>
</DxTreeList>
</template>
<script setup lang="ts">
import { DxTreeList, DxColumn, DxScrolling, DxPaging, DxAI } from 'devextreme-vue/tree-list';
import Employee from './Employee.vue';
import Status from './Status.vue';
import { type IEmployee, employees } from './data.ts';
import { aiIntegration } from './service.ts';
const onAIColumnRequestCreating = (e: { data: Partial<IEmployee>[] }) => {
e.data = e.data.map((item) => ({
ID: item.ID,
First_Name: item.First_Name,
Last_Name: item.Last_Name,
Title: item.Title,
}));
};
</script>
<style scoped>
#app .ai__cell {
background-color: var(--dx-datagrid-row-alternation-bg);
}
.ai__grid {
min-height: 560px;
}
#app .employee__cell > div {
align-items: flex-end;
}
</style>
<template>
<div class="employee__wrapper">
<div class="employee__img-wrapper">
<img
:src="`../../../../images/employees/new/${firstName} ${lastName}.jpg`"
:alt="`${firstName} ${lastName}`"
>
</div>
<div class="employee__text-wrapper">
<div class="employee__text">{{ firstName }}</div>
<div class="employee__text">{{ lastName }}</div>
</div>
</div>
</template>
<script setup lang="ts">
defineProps<{
firstName: string;
lastName: string;
}>();
</script>
<style scoped>
.employee__wrapper {
display: flex;
align-items: center;
gap: 8px;
}
.employee__img-wrapper {
width: 40px;
height: 40px;
border: var(--dx-border-width) solid var(--dx-color-border);
border-radius: 50%;
cursor: pointer;
}
.employee__img-wrapper img {
width: 100%;
height: 100%;
object-fit: cover;
object-position: center;
border-radius: 50%;
}
.employee__text-wrapper {
width: calc(100% - 48px);
}
.employee__text {
margin: 0;
padding: 0;
white-space: nowrap;
overflow: hidden;
text-overflow: ellipsis;
}
</style>
<template>
<div :class="`status status--${status.toLowerCase()}`">
<div class="status__indicator"/>
<div>{{ status }}</div>
</div>
</template>
<script setup lang="ts">
defineProps<{
status: string,
}>();
</script>
<style scoped>
.status {
display: flex;
align-items: center;
}
.status--salaried {
color: var(--dx-color-success);
}
.status--commission {
color: #f7630c;
}
.status--terminated {
color: var(--dx-color-danger);
}
.status__indicator {
background-color: currentcolor;
margin-right: 8px;
border-radius: 50%;
height: 12px;
width: 12px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'openai': 'externals:openai.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"openai": {
"version": "4.73.1"
}
};
export interface IEmployee {
ID: number;
Head_ID: number;
First_Name: string;
Last_Name: string;
Prefix: string;
Title: string;
City: string;
State: string;
Email: string;
Skype?: string;
Mobile_Phone: string;
Birth_Date: string;
Hire_Date: string;
Status: string;
}
export const employees: IEmployee[] = [{
ID: 1,
Head_ID: 0,
First_Name: 'John',
Last_Name: 'Heart',
Prefix: 'Mr.',
Title: 'CEO',
City: 'Los Angeles',
State: 'California',
Email: 'jheart@dx-email.com',
Skype: 'jheart_DX_skype',
Mobile_Phone: '(213) 555-9392',
Birth_Date: '1964-03-16',
Hire_Date: '1995-01-15',
Status: 'Salaried',
}, {
ID: 3,
Head_ID: 1,
First_Name: 'Arthur',
Last_Name: 'Miller',
Prefix: 'Mr.',
Title: 'CTO',
City: 'Los Angeles',
State: 'California',
Email: 'arthurm@dx-email.com',
Mobile_Phone: '+1 (310) 555-8583',
Birth_Date: '1972-07-11',
Hire_Date: '2007-12-18',
Status: 'Salaried',
}, {
ID: 4,
Head_ID: 1,
First_Name: 'Robert',
Last_Name: 'Reagan',
Prefix: 'Mr.',
Title: 'CMO',
City: 'Pasadena',
State: 'California',
Email: 'robertr@dx-email.com',
Mobile_Phone: '+1 (818) 555-2387',
Birth_Date: '1974-09-07',
Hire_Date: '2002-11-08',
Status: 'Salaried',
}, {
ID: 5,
Head_ID: 1,
First_Name: 'Greta',
Last_Name: 'Sims',
Prefix: 'Ms.',
Title: 'HR Manager',
City: 'Alhambra',
State: 'California',
Email: 'gretas@dx-email.com',
Mobile_Phone: '+1 (818) 555-6546',
Birth_Date: '1977-11-22',
Hire_Date: '1998-04-23',
Status: 'Salaried',
}, {
ID: 6,
Head_ID: 3,
First_Name: 'Brett',
Last_Name: 'Wade',
Prefix: 'Mr.',
Title: 'IT Manager',
City: 'San Marino',
State: 'California',
Email: 'brettw@dx-email.com',
Mobile_Phone: '+1 (626) 555-0358',
Birth_Date: '1968-12-01',
Hire_Date: '2009-03-06',
Status: 'Salaried',
}, {
ID: 7,
Head_ID: 5,
First_Name: 'Sandra',
Last_Name: 'Johnson',
Prefix: 'Mrs.',
Title: 'Controller',
City: 'Long Beach',
State: 'California',
Email: 'sandraj@dx-email.com',
Mobile_Phone: '+1 (562) 555-2082',
Birth_Date: '1974-11-15',
Hire_Date: '2005-05-11',
Status: 'Salaried',
}, {
ID: 21,
Head_ID: 6,
First_Name: 'Taylor',
Last_Name: 'Riley',
Prefix: 'Mr.',
Title: 'Network Admin',
City: 'West Hollywood',
State: 'California',
Email: 'taylorr@dx-email.com',
Mobile_Phone: '+1 (310) 555-7276',
Birth_Date: '1982-08-14',
Hire_Date: '2012-04-14',
Status: 'Salaried',
}, {
ID: 22,
Head_ID: 6,
First_Name: 'Amelia',
Last_Name: 'Harper',
Prefix: 'Mrs.',
Title: 'Network Admin',
City: 'Los Angeles',
State: 'California',
Email: 'ameliah@dx-email.com',
Mobile_Phone: '+1 (213) 555-4276',
Birth_Date: '1983-11-19',
Hire_Date: '2011-02-10',
Status: 'Salaried',
}, {
ID: 25,
Head_ID: 6,
First_Name: 'Karen',
Last_Name: 'Goodson',
Prefix: 'Miss',
Title: 'Programmer',
City: 'South Pasadena',
State: 'California',
Email: 'kareng@dx-email.com',
Mobile_Phone: '+1 (626) 555-0908',
Birth_Date: '1987-04-26',
Hire_Date: '2011-03-14',
Status: 'Salaried',
}, {
ID: 28,
Head_ID: 6,
First_Name: 'Morgan',
Last_Name: 'Kennedy',
Prefix: 'Mrs.',
Title: 'Graphic Designer',
City: 'San Fernando Valley',
State: 'California',
Email: 'morgank@dx-email.com',
Mobile_Phone: '+1 (818) 555-8238',
Birth_Date: '1984-07-17',
Hire_Date: '2012-01-11',
Status: 'Salaried',
}, {
ID: 29,
Head_ID: 28,
First_Name: 'Violet',
Last_Name: 'Bailey',
Prefix: 'Ms.',
Title: 'Jr Graphic Designer',
City: 'La Canada',
State: 'California',
Email: 'violetb@dx-email.com',
Mobile_Phone: '+1 (818) 555-2478',
Birth_Date: '1985-06-10',
Hire_Date: '2012-01-19',
Status: 'Salaried',
}, {
ID: 32,
Head_ID: 3,
First_Name: 'Bart',
Last_Name: 'Arnaz',
Prefix: 'Mr.',
Title: 'Director of Engineering',
City: 'Irvine',
State: 'California',
Email: 'barta@dx-email.com',
Mobile_Phone: '+1 (714) 555-2000',
Birth_Date: '1979-11-01',
Hire_Date: '2008-06-29',
Status: 'Salaried',
}, {
ID: 36,
Head_ID: 32,
First_Name: 'Samantha',
Last_Name: 'Piper',
Prefix: 'Ms.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'samanthap@dx-email.com',
Mobile_Phone: '+1 (323) 555-4512',
Birth_Date: '1984-12-01',
Hire_Date: '2008-01-22',
Status: 'Salaried',
}, {
ID: 38,
Head_ID: 32,
First_Name: 'Terry',
Last_Name: 'Bradley',
Prefix: 'Mr.',
Title: 'QA Engineer',
City: 'Simi Valley',
State: 'California',
Email: 'terryb@dx-email.com',
Mobile_Phone: '+1 (805) 555-2788',
Birth_Date: '1984-01-09',
Hire_Date: '2007-10-18',
Status: 'Salaried',
}, {
ID: 44,
Head_ID: 4,
First_Name: 'Clark',
Last_Name: 'Morgan',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Martinez',
State: 'California',
Email: 'clarkm@dx-email.com',
Mobile_Phone: '+1 (925) 555-2525',
Birth_Date: '1988-04-07',
Hire_Date: '2012-04-11',
Status: 'Commission',
}, {
ID: 45,
Head_ID: 4,
First_Name: 'Todd',
Last_Name: 'Hoffman',
Prefix: 'Mr.',
Title: 'Retail Sales Manager',
City: 'Livermore',
State: 'California',
Email: 'toddh@dx-email.com',
Mobile_Phone: '+1 (925) 555-3579',
Birth_Date: '1987-03-25',
Hire_Date: '2012-04-19',
Status: 'Commission',
}, {
ID: 48,
Head_ID: 32,
First_Name: 'Brad',
Last_Name: 'Farkus',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'bradf@dx-email.com',
Mobile_Phone: '+1 (213) 555-3626',
Birth_Date: '1991-03-17',
Hire_Date: '2010-04-15',
Status: 'Terminated',
}, {
ID: 51,
Head_ID: 32,
First_Name: 'Stu',
Last_Name: 'Pizaro',
Prefix: 'Mr.',
Title: 'Engineer',
City: 'Los Angeles',
State: 'California',
Email: 'stu@dx-email.com',
Mobile_Phone: '+1 (213) 555-2552',
Birth_Date: '1985-09-11',
Hire_Date: '2011-07-19',
Status: 'Terminated',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
import { AzureOpenAI, OpenAI } from 'openai';
import {
AIIntegration,
type RequestParams,
type Response,
} from 'devextreme-vue/common/ai-integration';
import notify from 'devextreme/ui/notify';
type AIMessage = (OpenAI.ChatCompletionUserMessageParam | OpenAI.ChatCompletionSystemMessageParam) & {
content: string;
};
const AzureOpenAIConfig = {
dangerouslyAllowBrowser: true,
deployment: 'gpt-4o-mini',
apiVersion: '2024-02-01',
endpoint: 'https://public-api.devexpress.com/demo-openai',
apiKey: 'DEMO',
};
const RATE_LIMIT_RETRY_DELAY_MS = 30000;
const MAX_PROMPT_SIZE = 5000;
const service = new AzureOpenAI(AzureOpenAIConfig);
async function getAIResponse(messages: AIMessage[], signal: AbortSignal) {
const params = {
messages,
model: AzureOpenAIConfig.deployment,
max_tokens: 1000,
temperature: 0.7,
};
const response = await service.chat.completions.create(params, { signal });
const result = response.choices[0].message?.content;
if (!result) {
throw new Error('AI response returned empty content');
}
return result;
}
async function getAIResponseRecursive(messages: AIMessage[], signal: AbortSignal): Promise<string> {
return getAIResponse(messages, signal)
.catch(async (error) => {
if (!error.message.includes('Connection error')) {
return Promise.reject(error);
}
notify({
message: 'Our demo AI service reached a temporary request limit. Retrying in 30 seconds.',
width: 'auto',
type: 'error',
displayTime: 5000,
});
await new Promise((resolve) => setTimeout(resolve, RATE_LIMIT_RETRY_DELAY_MS));
return getAIResponseRecursive(messages, signal);
});
}
export const aiIntegration = new AIIntegration({
sendRequest({ prompt }: RequestParams): Response {
const isValidRequest = JSON.stringify(prompt.user).length < MAX_PROMPT_SIZE;
if (!isValidRequest) {
return {
promise: Promise.reject(new Error('Request is too long. Specify a shorter prompt.')),
abort: () => {},
};
}
const controller = new AbortController();
const signal = controller.signal;
if (!prompt.user || !prompt.system) {
throw new Error('Invalid prompt data');
}
const aiPrompt: AIMessage[] = [
{ role: 'system', content: prompt.system },
{ role: 'user', content: prompt.user },
];
const promise = getAIResponseRecursive(aiPrompt, signal);
const result: Response = {
promise,
abort: () => {
controller.abort();
},
};
return result;
},
});
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>